package com.ruoyi.e.order.service.impl;

import cn.hutool.core.util.ObjectUtil;
import com.ruoyi.common.core.domain.BaseValidator;
import com.ruoyi.common.core.domain.ValidateResult;
import com.ruoyi.common.core.domain.entity.EUser;
import com.ruoyi.common.core.domain.entity.EUserVO;
import com.ruoyi.common.utils.ServiceUtil;
import com.ruoyi.e.order.domain.order.EOrderVO;
import com.ruoyi.e.order.domain.order.bo.EOrderBO;
import com.ruoyi.e.order.service.IEOrderService;
import com.ruoyi.e.order.service.IEOrderValidator;
import com.ruoyi.system.domain.device.EDevice;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.util.List;

@Service
public class IOrderValidatorImpl extends BaseValidator implements IEOrderValidator {

    @Autowired
    private IEOrderService orderService;


    @Override
    public ValidateResult preAddOrder(EOrderBO bo) {
        if (bo == null) {
            return error("数据不能为空");
        }

        EDevice device = bo.getDevice();
        EUserVO user = bo.getUser();

        List<EOrderVO> order = orderService.getInProgressOrder(null,device.getSn());
        if(ObjectUtil.isNotNull(order) && !order.isEmpty()){
            return error("该车辆还有正在进行中的订单");
        }

//        List<EOrderVO> order1 = orderService.getInProgressOrder(user.getUserId(),null);
//        if(ObjectUtil.isNotNull(order1) && !order1.isEmpty()){
//            return error("该用户还有正在进行中的订单");
//        }

        // todo    用户还有未支付的订单
        //         √营业时间
        //        √用户还有进行中的订单
        //        √车辆还有进行中的订单
        //        价格已发生变化
        //        价格未配置
        //        小时未配置
//        RechargeDTO dto = bo.getParams();
//
//        // 用户
//        SmUserVO user = bo.getUser();
//        // 检查用户是否有未支付的智能分时段订单
//        if (this.hasUnpaidSmartTimingOrder(user.getUserId())) {
//            return error("您有未支付的订单，请先支付后继续");
//        }
//        // 检查用户是否有正在使用中的智能订单
//        if (this.hasUsingSmartOrder(user.getUserId())) {
//            return error("您有正在使用中的智能订单，请结束后继续");
//        }
//
//        // 检查设备是否符合条件
//        DeviceVO device = bo.getDevice();
//        if (device == null || device.getDeleted()) {
//            return error("当前设备不存在");
//        }
//        if (StringUtils.isEmpty(device.getMac())) {
//            return error("当前设备Mac为空，无法充值");
//        }
//        if (device.getLimitRechargeTime() != null && LocalDateTime.now().isBefore(device.getLimitRechargeTime())) {
//            return error("当前设备被限制充值：" + device.getLimitRechargeReason());
//        }
//
//        // 判断设备是否有正在使用中的订单
//        TransactionBillQuery query = new TransactionBillQuery();
//        query.setDeviceId(device.getDeviceId());
//        List<TransactionBillVO> usingBill = transactionBillService.selectUsingBill(query);
//        if (CollectionUtils.isNotEmptyElement(usingBill)) {
//            return error("该设备有正在使用中的订单，暂时无法下单");
//        }
//
//        // 商户检查
//        SmUserVO mch = bo.getMch();
//        if (!userValidator.isUsage(device.getUserId())) {
//            return error("当前设备商户不存在或不可用，无法充值，请确认商户账号是否正常");
//        }
//        // 若商户开启了获取用户手机号，则判断用户是否有手机号
//        if (mch.getShowBillMobile() != null && mch.getShowBillMobile() && StringUtils.isBlank(user.getPhonenumber())) {
//            return error("当前用户未绑定手机号，无法下单");
//        }
//
//        // 套餐检查
//        SuitVO suit = bo.getSuit();
//        if (suit == null) {
//            return error("当前设备套餐不存在");
//        }
//        List<Long> suitDeviceIds = suit.getDeviceList().stream().map(DeviceVO::getDeviceId).collect(Collectors.toList());   // 套餐应用的设备列表
//        if (!suitDeviceIds.contains(device.getDeviceId())) {
//            return error("当前设备没有该套餐");
//        }
//        if (suit.getPrice() == null) {
//            return error("当前套餐未配置价格，请联系商户处理");
//        }
//        if (suit.getPrice().compareTo(dto.getSuitPrice()) != 0) {
//            return error("当前套餐价格已发生变化，请重新下单");
//        }
//        if (SuitFeeMode.SMART.getMode().equals(suit.getFeeMode())) {
//            if (suit.getDeposit().compareTo(dto.getSuitDeposit()) != 0) {
//                return error("当前套餐押金已发生变化，请重新下单");
//            }
//        }
//        if (!suit.getFeeMode().equals(dto.getSuitFeeMode())) {
//            return error("当前套餐套餐发生变化，请重新下单");
//        }
//        if (!suit.getFeeType().equals(dto.getSuitFeeType())) {
//            return error("当前套餐收费类型发生变化，请重新下单");
//        }
//        if (SuitFeeType.singleList().contains(suit.getFeeType())) {
//            // 一次性收费需要配置时间/度数
//            if (suit.getValue() == null) {
//                return error("当前套餐未配置时间/电量，请联系商户处理");
//            }
//            if (SuitFeeType.needConfigTimeUnit().contains(suit.getFeeType()) && suit.getTimeUnit() == null) {
//                return error("当前套餐未配置时长单位，请联系商户处理");
//            }
//        }
//        if (!Objects.equals(suit.getValue(), dto.getSuitTime())) {
//            return error("当前套餐时间/度数已发生变化，请重新下单");
//        }
//        if (!Objects.equals(suit.getTimeUnit(), dto.getSuitTimeUnit())) {
//            return error("当前套餐时间已发生变化，请重新下单");
//        }
//        if (!CollectionUtils.equals(suit.getGearAmount(), dto.getSuitGearAmount())) {
//            return error("套餐收费方式已发生变化，请重新下单");
//        }
//        if (!CollectionUtils.equals(suit.getGearTime(), dto.getSuitGearTime())) {
//            return error("套餐收费方式已发生变化，请重新下单");
//        }

//        if (SuitFeeMode.SMART.getMode().equals(suit.getFeeMode())) {
//            if (device.getExpireTime() != null && device.getExpireTime().isAfter(LocalDateTime.now())) {
//                return error("当前设备还有剩余时长，无法选择智能收费方式下单");
//            }
//            if (DeviceOnlineStatus.ONLINE.getStatus().equals(device.getOnlineStatus())
//                    && device.getSurplusEle() != null
//                    && device.getSurplusEle().compareTo(BigDecimal.ZERO) > 0) {
//                return error("当前设备还有剩余电量，无法选择智能收费方式下单");
//            }
//        }
        return success();
    }



//    @Override
//    public void validateChangeRoom(OrderQuery orderQuery) {
//        if(StrUtil.isBlank(orderQuery.getOrderNo())){
//            throw new ServiceException("订单号不能为空");
//        }
//        if(orderQuery.getNewRoomId() == null){
//            throw new ServiceException("新包间id不能为空");
//        }
//        OrderVO orderVO = orderService.selectRlOrderByOrderNo(orderQuery.getOrderNo());
//        ServiceUtil.assertion(orderVO == null, "订单不存在");
//        ServiceUtil.assertion(orderVO.getPaid() == null || orderVO.getPaid().equals(ServiceConstants.ORDER_PAY_STATUS_NON_PAYMENT), "订单未支付");
//        ServiceUtil.assertion(orderVO.getStatus() == null || !orderVO.getStatus().equals(ServiceConstants.ORDER_STATUS_PAYMENT_SUCCESS), "订单使用状态");
//
//        RoomVO newRoom = roomService.selectERoomByRoomId(orderQuery.getNewRoomId());
//        ServiceUtil.assertion(newRoom == null, "新包间不存在");
//        ServiceUtil.assertion(newRoom.getStoreId() == null || !newRoom.getStoreId().equals(orderVO.getStoreId()), "新包间不属于当前店铺，不能更换");
//        ServiceUtil.assertion(newRoom.getStatus() == null || !newRoom.getStatus().equals(ServiceConstants.ROOM_STATUS_FREE), "新包间非空闲状态，不能更换");
//        ServiceUtil.assertion(newRoom.getType() == null || !newRoom.getType().equals(orderVO.getRoomType()), "新包间类型与原包间类型不一致，不能更换");
//        ServiceUtil.assertion(Objects.equals(orderVO.getRoomId(), newRoom.getRoomId()), "新包间与原包间相同，无需更换");
//
//        // 新包间在订单时间内是否有预定单  在指定时间段内是否有订单
//        Date reserveStartTime = orderVO.getReserveStartTime();
//        Date reserveEndTime = orderVO.getReserveEndTime();// 是否被预定  已
//        int isReserved = orderService.isReserved(newRoom.getRoomId(), reserveStartTime, reserveEndTime);
//        String reserveStartTimeString =  new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(reserveStartTime);
//        String reserveEndTimeString =  new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(reserveEndTime);
//        ServiceUtil.assertion(isReserved > 1, "新包间在【"+reserveStartTimeString+"】~【"+reserveEndTimeString+"】时间段内有预定单，不能更换");
//
//    }

    @Override
    public void checkDividendProportions(List<EUser> dividendUsers) {
        // 使用Stream处理累加所有用户的分账比例，并且检查是否大于1
        BigDecimal totalProportion = dividendUsers.stream()
                // 映射成 BigDecimal 的分账比例
                .map(EUser::getDividendProportion)
                // 累加所有比例
                .reduce(BigDecimal.ZERO, BigDecimal::add);
        // 校验
        ServiceUtil.assertion(totalProportion.compareTo(BigDecimal.ONE) > 0,"分账总比例不能大于100%");
    }


}
