package com.ruoyi.system.mapper;

import com.ruoyi.system.domain.rule.EFeeRule;
import com.ruoyi.system.domain.rule.EFeeRuleVO;

import java.util.List;

/**
 * 收费模板Mapper接口
 *
 * @author qzz
 * @date 2024-09-19
 */
public interface EFeeRuleMapper
{
    /**
     * 查询收费模板
     *
     * @param ruleId 收费模板主键
     * @return 收费模板
     */
    public EFeeRuleVO selectRlFeeRuleByRuleId(Long ruleId);

    /**
     * 查询收费模板列表
     *
     * @param rlFeeRule 收费模板
     * @return 收费模板集合
     */
    public List<EFeeRule> selectRlFeeRuleList(EFeeRule rlFeeRule);

    /**
     * 新增收费模板
     *
     * @param rlFeeRule 收费模板
     * @return 结果
     */
    public int insertRlFeeRule(EFeeRule rlFeeRule);

    /**
     * 修改收费模板
     *
     * @param rlFeeRule 收费模板
     * @return 结果
     */
    public int updateRlFeeRule(EFeeRule rlFeeRule);

    /**
     * 删除收费模板
     *
     * @param ruleId 收费模板主键
     * @return 结果
     */
    public int deleteRlFeeRuleByRuleId(Long ruleId);

    /**
     * 批量删除收费模板
     *
     * @param ruleIds 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteRlFeeRuleByRuleIds(Long[] ruleIds);

    /**
     * 查询收费模板列表
     *
     * @param modelId 车型id
     * @return 收费模板
     */
    public List<EFeeRule> selectRlFeeRuleListByModelId(Long modelId);

    /**
     * 查询收费模板列表ids
     *
     * @param modelId 车型id
     * @return 收费模板集合
     */
    List<Long> selectRlFeeRuleLongListByModelId(Long modelId);

}
